=== modified file '.bzrignore'
--- .bzrignore	2012-01-18 13:07:18 +0000
+++ .bzrignore	2012-01-19 17:35:21 +0000
@@ -4,4 +4,5 @@
 test/coverage_summary
 test/output
 help/*
-data/xapian/*
\ No newline at end of file
+data/xapian/*
+.backup

=== modified file 'softwarecenter/db/application.py'
--- softwarecenter/db/application.py	2011-12-16 01:52:15 +0000
+++ softwarecenter/db/application.py	2012-01-19 17:35:21 +0000
@@ -38,10 +38,10 @@
 # this is a very lean class as its used in the main listview
 # and there are a lot of application objects in memory
 class Application(object):
-    """ The central software item abstraction. it contains a 
+    """ The central software item abstraction. it contains a
         pkgname that is always available and a optional appname
         for packages with multiple applications
-        
+
         There is also a __cmp__ method and a name property
     """
     def __init__(self, appname="", pkgname="", request="", popcon=0):
@@ -78,7 +78,7 @@
 
     def get_untranslated_app(self, db):
         """ return a Application object with the untranslated application
-            name 
+            name
         """
         try:
             doc = db.get_xapian_document(self.appname, self.pkgname)
@@ -111,7 +111,7 @@
                 return db.get_summary(doc)
             else:
                 return db.get_pkgname(doc)
-        
+
     # special methods
     def __hash__(self):
         return ("%s:%s" % (self.appname, self.pkgname)).__hash__()
@@ -172,8 +172,8 @@
         # load application
         self._app = application
         if doc:
-            self._app = Application(self._db.get_appname(doc), 
-                                    self._db.get_pkgname(doc), 
+            self._app = Application(self._db.get_appname(doc),
+                                    self._db.get_pkgname(doc),
                                     "")
 
         # sustitute for apturl
@@ -183,7 +183,7 @@
 
         # load pkg cache
         self._pkg = None
-        if (self._app.pkgname in self._cache and 
+        if (self._app.pkgname in self._cache and
             self._cache[self._app.pkgname].candidate):
             self._pkg = self._cache[self._app.pkgname]
 
@@ -197,13 +197,13 @@
                 # if there is no document and no apturl request,
                 # set error state
                 debfile_matches = re.findall(r'/', self._app.request)
-                channel_matches = re.findall(r'channel=[a-z,-]*', 
-                                             self._app.request)
-                section_matches = re.findall(r'section=[a-z]*', 
-                                             self._app.request)
-                if (not self._pkg and 
-                    not debfile_matches and 
-                    not channel_matches and 
+                channel_matches = re.findall(r'channel=[a-z,-]*',
+                                             self._app.request)
+                section_matches = re.findall(r'section=[a-z]*',
+                                             self._app.request)
+                if (not self._pkg and
+                    not debfile_matches and
+                    not channel_matches and
                     not section_matches):
                     self._error = _("Not found")
                     self._error_not_found = utf8(_(u"There isn\u2019t a software package called \u201c%s\u201D in your current software sources.")) % utf8(self.pkgname)
@@ -253,10 +253,10 @@
 
     @property
     def component(self):
-        """ 
+        """
         get the component (main, universe, ..)
-        
-        this uses the data from apt, if there is none it uses the 
+
+        this uses the data from apt, if there is none it uses the
         data from the app-install-data files
         """
         # try apt first
@@ -318,12 +318,12 @@
             return split_icon_ext(self._db.get_iconname(self._doc))
         if not self.summary:
             return Icons.MISSING_PKG
-            
+
     @property
     def icon_file_name(self):
         if self._doc:
             return self._db.get_iconname(self._doc)
-    
+
     @property
     def icon_url(self):
         if self._doc:
@@ -368,7 +368,7 @@
     @property
     def maintenance_status(self):
         return self._distro.get_maintenance_status(
-            self._cache, self.display_name, self.pkgname, self.component, 
+            self._cache, self.display_name, self.pkgname, self.component,
             self.channelname)
 
     @property
@@ -496,7 +496,7 @@
             if self._doc.get_value(XapianValues.SCREENSHOT_URL):
                 return self._doc.get_value(XapianValues.SCREENSHOT_URL)
         # else use the default
-        return self._distro.SCREENSHOT_LARGE_URL % { 'pkgname' : self.pkgname, 
+        return self._distro.SCREENSHOT_LARGE_URL % { 'pkgname' : self.pkgname,
                                                      'version' : self.version or 0 }
 
     @property
@@ -566,7 +566,7 @@
             if self._doc.get_value(XapianValues.THUMBNAIL_URL):
                 return self._doc.get_value(XapianValues.THUMBNAIL_URL)
         # else use the default
-        return self._distro.SCREENSHOT_THUMB_URL % { 'pkgname' : self.pkgname, 
+        return self._distro.SCREENSHOT_THUMB_URL % { 'pkgname' : self.pkgname,
                                                      'version' : self.version or 0}
 
     @property
@@ -576,7 +576,7 @@
             if self._doc.get_value(XapianValues.VIDEO_URL):
                 return self._doc.get_value(XapianValues.VIDEO_URL)
         # else use the video server
-        #return self._distro.VIDEO_URL % { 'pkgname' : self.pkgname, 
+        #return self._distro.VIDEO_URL % { 'pkgname' : self.pkgname,
         #                                  'version' : self.version or 0}
         return None
 
@@ -587,6 +587,8 @@
                 return self._pkg.installed.version
             else:
                 return self._pkg.candidate.version
+        elif self._doc:
+            return self._doc.get_value(XapianValues.VERSION_INFO)
 
     @property
     def warning(self):
@@ -604,7 +606,7 @@
             source_to_enable = None
             if self.channelname and self._unavailable_channel():
                 source_to_enable = self.channelname
-            elif (self.component and 
+            elif (self.component and
                   self.component not in ("independent", "commercial")):
                 source_to_enable = self.component
             if source_to_enable:
@@ -613,9 +615,9 @@
                 if sources_length == 1:
                     warning = _("Available from the \"%s\" source.") % sources[0]
                 elif sources_length > 1:
-                    # Translators: the visible string is constructed concatenating 
-                    # the following 3 strings like this: 
-                    # Available from the following sources: %s, ... %s, %s.                
+                    # Translators: the visible string is constructed concatenating
+                    # the following 3 strings like this:
+                    # Available from the following sources: %s, ... %s, %s.
                     warning = _("Available from the following sources: ")
                     # Cycle through all, but the last
                     for source in sources[:-1]:
@@ -632,7 +634,7 @@
     def supportsite(self):
         if self._doc:
             return self._doc.get_value(XapianValues.SUPPORT_SITE_URL)
-    
+
     @property
     def license_key(self):
         if self._doc:

=== modified file 'softwarecenter/db/update.py'
--- softwarecenter/db/update.py	2012-01-18 09:38:45 +0000
+++ softwarecenter/db/update.py	2012-01-19 17:35:21 +0000
@@ -152,6 +152,7 @@
                 'Support-Url'   : 'support_url',
                 'Description' : 'Description',
                 'Comment' : 'Comment',
+                'Version' : 'version',
               }
 
     # map from requested key to a static data element
@@ -167,7 +168,7 @@
         # for items from the agent, we use the full-size screenshot for
         # the thumbnail and scale it for display, this is done because
         # we no longer keep thumbnail versions of screenshots on the server
-        if (hasattr(self.sca_application, "screenshot_url") and 
+        if (hasattr(self.sca_application, "screenshot_url") and
             not hasattr(self.sca_application, "thumbnail_url")):
             self.sca_application.thumbnail_url = self.sca_application.screenshot_url
         if hasattr(self.sca_application, "description"):
@@ -222,7 +223,7 @@
         self.sca_application.channel = (
             PURCHASED_NEEDS_REINSTALL_MAGIC_CHANNEL_NAME)
 
-    SUBSCRIPTION_MAPPING = { 
+    SUBSCRIPTION_MAPPING = {
         'Deb-Line'   : 'deb_line',
         'Purchased-Date' : 'purchase_date',
         'License-Key' : 'license_key',
@@ -277,7 +278,7 @@
                 'Keywords'   : 'keywords',
                 'MimeType'   : 'mimetypes',
                 'Icon'       : 'icon',
-              } 
+              }
 
     LISTS = { "appcategories" : "appcategory",
               "keywords"  : "keyword",
@@ -327,7 +328,7 @@
                 l.append(child.text)
         return ",".join(l)
     def has_option_desktop(self, key):
-        if key in self.STATIC_DATA: 
+        if key in self.STATIC_DATA:
             return True
         key = self._apply_mapping(key)
         return not self.appinfo_xml.find(key) is None
@@ -399,7 +400,7 @@
                 translated_value = gettext.dgettext(domain, value)
                 if value != translated_value:
                     return translated_value
-        # then try app-install-data 
+        # then try app-install-data
         value = self.get(self.DE, key)
         if value:
             translated_value = gettext.dgettext("app-install-data", value)
@@ -509,7 +510,7 @@
             context.iteration()
         update_from_single_appstream_file(db, cache, appstream_xml)
     return True
-        
+
 def update_from_app_install_data(db, cache, datadir=None):
     """ index the desktop files in $datadir/desktop/*.desktop """
     if not datadir:
@@ -538,7 +539,7 @@
 
 def add_from_purchased_but_needs_reinstall_data(purchased_but_may_need_reinstall_list, db, cache):
     """Add application that have been purchased but may require a reinstall
-    
+
     This adds a inmemory database to the main db with the special
     PURCHASED_NEEDS_REINSTALL_MAGIC_CHANNEL_NAME channel prefix
 
@@ -598,7 +599,7 @@
         sca.query_available_qa()
     else:
         sca.query_available()
-    # create event loop and run it until data is available 
+    # create event loop and run it until data is available
     # (the _available_cb and _error_cb will quit it)
     context = GObject.main_context_default()
     loop = GObject.MainLoop(context)
@@ -617,7 +618,7 @@
     # return true if we have updated entries (this can also be an empty list)
     # but only if we did not got a error from the agent
     return sca.good_data
-        
+
 def index_app_info_from_parser(parser, db, cache):
         term_generator = xapian.TermGenerator()
         term_generator.set_database(db)
@@ -683,7 +684,7 @@
         # cataloged_times
         if "catalogedtime" in axi_values:
             if pkgname in cataloged_times:
-                doc.add_value(axi_values["catalogedtime"], 
+                doc.add_value(axi_values["catalogedtime"],
                               xapian.sortable_serialise(cataloged_times[pkgname]))
         # pocket (main, restricted, ...)
         if parser.has_option_desktop("X-AppInstall-Section"):
@@ -723,7 +724,7 @@
                     date_published_sec = time.mktime(
                                             time.strptime(date_published,
                                                           "%Y-%m-%d  %H:%M:%S"))
-                    doc.add_value(axi_values["catalogedtime"], 
+                    doc.add_value(axi_values["catalogedtime"],
                                   xapian.sortable_serialise(date_published_sec))
         # purchased date
         if parser.has_option_desktop("X-AppInstall-Purchased-Date"):
@@ -761,6 +762,10 @@
         if parser.has_option_desktop("X-AppInstall-Video-Url"):
             url = parser.get_desktop("X-AppInstall-Video-Url")
             doc.add_value(XapianValues.VIDEO_URL, url)
+        # version support (for e.g. the scagent)
+        if parser.has_option_desktop("X-AppInstall-Version"):
+            ver = parser.get_desktop("X-AppInstall-Version")
+            doc.add_value(XapianValues.VERSION_INFO, ver)
         # icon (for third party)
         if parser.has_option_desktop("X-AppInstall-Icon-Url"):
             url = parser.get_desktop("X-AppInstall-Icon-Url")
@@ -809,7 +814,7 @@
         if parser.has_option_desktop("X-AppInstall-Popcon"):
             popcon = float(parser.get_desktop("X-AppInstall-Popcon"))
             # sort_by_value uses string compare, so we need to pad here
-            doc.add_value(XapianValues.POPCON, 
+            doc.add_value(XapianValues.POPCON,
                           xapian.sortable_serialise(popcon))
             global popcon_max
             popcon_max = max(popcon_max, popcon)
@@ -873,7 +878,7 @@
     cache.open()
     old_path = pathname+"_old"
     rebuild_path = pathname+"_rb"
-    
+
     if not os.path.exists(rebuild_path):
         try:
             os.makedirs(rebuild_path)
@@ -881,13 +886,13 @@
             LOG.warn("Problem creating rebuild path '%s'." % rebuild_path)
             LOG.warn("Please check you have the relevant permissions.")
             return False
-    
+
     # check permission
     if not os.access(pathname, os.W_OK):
         LOG.warn("Cannot write to '%s'." % pathname)
         LOG.warn("Please check you have the relevant permissions.")
         return False
-    
+
     #check if old unrequired version of db still exists on filesystem
     if os.path.exists(old_path):
         LOG.warn("Existing xapian old db was not previously cleaned: '%s'." % old_path)
@@ -899,7 +904,7 @@
             LOG.warn("Please check you have the relevant permissions.")
             return False
 
-            
+
     # write it
     db = xapian.WritableDatabase(rebuild_path, xapian.DB_CREATE_OR_OVERWRITE)
 
@@ -919,7 +924,7 @@
         mo_time = os.path.getctime(mofile)
         db.set_metadata("app-install-mo-time", str(mo_time))
     db.flush()
-    
+
     # use shutil.move() instead of os.rename() as this will automatically
     # figure out if it can use os.rename or needs to do the move "manually"
     try:

=== modified file 'softwarecenter/enums.py'
--- softwarecenter/enums.py	2012-01-18 21:27:30 +0000
+++ softwarecenter/enums.py	2012-01-19 17:35:21 +0000
@@ -140,6 +140,7 @@
     VIDEO_URL = 195
     DATE_PUBLISHED = 196
     SUPPORT_SITE_URL = 197
+    VERSION_INFO = 198
 
 # fake channels
 PURCHASED_NEEDS_REINSTALL_MAGIC_CHANNEL_NAME = "for-pay-needs-reinstall"

